﻿using System;
using System.Windows.Forms;
using System.IO;
using System.Text.RegularExpressions;
using System.Collections;
using IWshRuntimeLibrary;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            if (System.IO.File.Exists("letzterPfad"))
            {
                using (TextReader tr = new StreamReader("letzterPfad"))
                {
                    folderBrowserDialog1.SelectedPath = tr.ReadLine();
                }
                schrittEins();
            }
        }

        public static ArrayList filmliste = new ArrayList();

        public int zufalls()
        {
            Random random = new Random();
            return random.Next(0, filmliste.Count);
        }

        private void schrittEins()
        {
            filmliste.Clear();
            using (StreamWriter sw = System.IO.File.CreateText("letzterPfad"))
            {
                sw.Write(folderBrowserDialog1.SelectedPath);
            }
            textBox1.Text = folderBrowserDialog1.SelectedPath;
            DirectoryInfo di = new DirectoryInfo(folderBrowserDialog1.SelectedPath);
            FileInfo[] rgFiles = di.GetFiles("*.*", SearchOption.TopDirectoryOnly);
            foreach (FileInfo fi in rgFiles) filmliste.Add(fi.Name);
            textBox2.Text = filmliste.Count + " Datei(en)";
            button2_Click(null, null);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                schrittEins();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            textBox3.Text = filmliste[zufalls()].ToString();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(folderBrowserDialog1.SelectedPath + "\\" + textBox3.Text);
        }

        private void Form1_DragDrop(object sender, DragEventArgs e)
        {
            string[] FileList = (string[])e.Data.GetData(DataFormats.FileDrop, false);
            if (Directory.Exists(FileList[0]))
            {
                folderBrowserDialog1.SelectedPath = FileList[0];
                schrittEins();
            }
            else if (System.IO.File.Exists(FileList[0]))
            {
                FileInfo test = new FileInfo(FileList[0]);
                if (test.Extension == ".lnk")
                {
                    WshShell shell = new WshShell();
                    IWshShortcut link = (IWshShortcut)shell.CreateShortcut(FileList[0]);
                    if (Directory.Exists(link.TargetPath)) folderBrowserDialog1.SelectedPath = link.TargetPath;
                    else
                    {
                        test = new FileInfo(link.TargetPath);
                        folderBrowserDialog1.SelectedPath = test.DirectoryName;
                    }
                }
                else
                {
                    folderBrowserDialog1.SelectedPath = test.DirectoryName;
                }
                schrittEins();
            }
        }

        private void Form1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.Copy;
            else
                e.Effect = DragDropEffects.None;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(folderBrowserDialog1.SelectedPath);
        }
    }
}
